Index: code/branches/pickup2/src/libraries/core/OrxonoxClass.cc
===================================================================
--- code/branches/pickup2/src/libraries/core/OrxonoxClass.cc	(revision 6405)
+++ code/branches/pickup2/src/libraries/core/OrxonoxClass.cc	(revision 6412)
@@ -34,4 +34,5 @@
 #include "OrxonoxClass.h"
 
+#include <cassert>
 #include "MetaObjectList.h"
 #include "Identifier.h"
@@ -48,4 +49,6 @@
         this->referenceCount_ = 0;
         this->requestedDestruction_ = false;
+        // Optimisation
+        this->objectPointers_.reserve(6);
     }
 
@@ -54,14 +57,14 @@
     {
 //        if (!this->requestedDestruction_)
-//            COUT(2) << "Warning: Destroyed object without destroy() (" << this->getIdentifier()->getName() << ")" << std::endl;
+//            COUT(2) << "Warning: Destroyed object without destroy() (" << this->getIdentifier()->getName() << ')' << std::endl;
 
         assert(this->referenceCount_ <= 0);
 
-        delete this->metaList_;
+        this->unregisterObject();
 
         // parents_ exists only if isCreatingHierarchy() of the associated Identifier returned true while creating the class
         if (this->parents_)
             delete this->parents_;
-            
+
         // reset all weak pointers pointing to this object
         for (std::set<WeakPtr<OrxonoxClass>*>::iterator it = this->weakPointers_.begin(); it != this->weakPointers_.end(); )
@@ -72,7 +75,19 @@
     void OrxonoxClass::destroy()
     {
+        assert(this); // Just in case someone tries to delete a NULL pointer
         this->requestedDestruction_ = true;
         if (this->referenceCount_ == 0)
-            delete this;
+        {
+            this->preDestroy();
+            if (this->referenceCount_ == 0)
+                delete this;
+        }
+    }
+
+    void OrxonoxClass::unregisterObject()
+    {
+        if (this->metaList_)
+            delete this->metaList_;
+        this->metaList_ = 0;
     }
 
Index: code/branches/pickup2/src/libraries/core/OrxonoxClass.h
===================================================================
--- code/branches/pickup2/src/libraries/core/OrxonoxClass.h	(revision 6405)
+++ code/branches/pickup2/src/libraries/core/OrxonoxClass.h	(revision 6412)
@@ -43,4 +43,11 @@
 #include <vector>
 
+/**
+@def CCOUT
+    Acts almost exactly like COUT(x), but prepends "ClassName: "
+*/
+#define CCOUT(level) \
+    COUT(level) << this->getIdentifier()->getName() << ": "
+
 namespace orxonox
 {
@@ -66,4 +73,5 @@
 
             void destroy();
+            void unregisterObject();
 
             /** @brief Function to collect the SetConfigValue-macro calls. */
@@ -127,4 +135,7 @@
             {   return const_cast<OrxonoxClass*>(this)->getDerivedPointer<T>(classID);   }
 
+        protected:
+            virtual void preDestroy() {}
+
         private:
             /** @brief Increments the reference counter (for smart pointers). */
@@ -133,6 +144,10 @@
             /** @brief Decrements the reference counter (for smart pointers). */
             inline void decrementReferenceCount()
-                { --this->referenceCount_; if (this->referenceCount_ == 0 && this->requestedDestruction_) { delete this; } }
-                
+            {
+                --this->referenceCount_;
+                if (this->referenceCount_ == 0 && this->requestedDestruction_)
+                    this->destroy();
+            }
+
             /** @brief Register a weak pointer which points to this object. */
             template <class T>
Index: code/branches/pickup2/src/libraries/core/PathConfig.cc
===================================================================
--- code/branches/pickup2/src/libraries/core/PathConfig.cc	(revision 6405)
+++ code/branches/pickup2/src/libraries/core/PathConfig.cc	(revision 6412)
@@ -54,5 +54,5 @@
 #include "util/Debug.h"
 #include "util/Exception.h"
-#include "CommandLine.h"
+#include "CommandLineParser.h"
 
 // Boost 1.36 has some issues with deprecated functions that have been omitted
@@ -186,6 +186,6 @@
 
             // Check for data path override by the command line
-            if (!CommandLine::getArgument("externalDataPath")->hasDefaultValue())
-                externalDataPath_ = CommandLine::getValue("externalDataPath").getString();
+            if (!CommandLineParser::getArgument("externalDataPath")->hasDefaultValue())
+                externalDataPath_ = CommandLineParser::getValue("externalDataPath").getString();
             else
                 externalDataPath_ = specialConfig::externalDataDevDirectory;
@@ -224,7 +224,7 @@
 
         // Option to put all the config and log files in a separate folder
-        if (!CommandLine::getArgument("writingPathSuffix")->hasDefaultValue())
-        {
-            std::string directory(CommandLine::getValue("writingPathSuffix").getString());
+        if (!CommandLineParser::getArgument("writingPathSuffix")->hasDefaultValue())
+        {
+            const std::string& directory(CommandLineParser::getValue("writingPathSuffix").getString());
             configPath_ = configPath_ / directory;
             logPath_    = logPath_    / directory;
@@ -256,10 +256,14 @@
 
         // We search for helper files with the following extension
-        std::string moduleextension = specialConfig::moduleExtension;
+        const std::string& moduleextension = specialConfig::moduleExtension;
         size_t moduleextensionlength = moduleextension.size();
 
         // Add that path to the PATH variable in case a module depends on another one
-        std::string pathVariable = getenv("PATH");
-        putenv(const_cast<char*>(("PATH=" + pathVariable + ";" + modulePath_.string()).c_str()));
+        std::string pathVariable(getenv("PATH"));
+        putenv(const_cast<char*>(("PATH=" + pathVariable + ';' + modulePath_.string()).c_str()));
+
+        // Make sure the path exists, otherwise don't load modules
+        if (!boost::filesystem::exists(modulePath_))
+            return modulePaths;
 
         boost::filesystem::directory_iterator file(modulePath_);
@@ -269,5 +273,5 @@
         while (file != end)
         {
-            std::string filename = file->BOOST_LEAF_FUNCTION();
+            const std::string& filename = file->BOOST_LEAF_FUNCTION();
 
             // Check if the file ends with the exension in question
@@ -277,5 +281,5 @@
                 {
                     // We've found a helper file
-                    std::string library = filename.substr(0, filename.size() - moduleextensionlength);
+                    const std::string& library = filename.substr(0, filename.size() - moduleextensionlength);
                     modulePaths.push_back((modulePath_ / library).file_string());
                 }
Index: code/branches/pickup2/src/libraries/core/PathConfig.h
===================================================================
--- code/branches/pickup2/src/libraries/core/PathConfig.h	(revision 6405)
+++ code/branches/pickup2/src/libraries/core/PathConfig.h	(revision 6412)
@@ -36,6 +36,8 @@
 #include "util/Singleton.h"
 
+//tolua_begin
 namespace orxonox
 {
+//tolua_end
     /**
     @brief
@@ -50,6 +52,7 @@
         - externalData only for development builds in the build tree
     */
-    class _CoreExport PathConfig : public Singleton<PathConfig>
-    {
+    class _CoreExport PathConfig //tolua_export
+        : public Singleton<PathConfig>
+    { //tolua_export
         friend class Singleton<PathConfig>;
         friend class Core;
@@ -99,5 +102,5 @@
             static std::string getExternalDataPathString();
             //! Returns the path to the config files as std::string
-            static std::string getConfigPathString();
+            static std::string getConfigPathString(); //tolua_export
             //! Returns the path to the log files as std::string
             static std::string getLogPathString();
@@ -132,6 +135,6 @@
             bool                     bDevRun_;               //!< True for runs in the build directory (not installed)
             static PathConfig* singletonPtr_s;
-    };
-}
+    }; //tolua_export
+} //tolua_export
 
 #endif /* _PathConfig_H__ */
Index: code/branches/pickup2/src/libraries/core/Resource.cc
===================================================================
--- code/branches/pickup2/src/libraries/core/Resource.cc	(revision 6405)
+++ code/branches/pickup2/src/libraries/core/Resource.cc	(revision 6412)
@@ -34,21 +34,46 @@
     std::string Resource::DEFAULT_GROUP(Ogre::ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME);
 
-    DataStreamPtr Resource::open(const std::string& name, const std::string& group, bool bSearchGroupsIfNotFound)
+    DataStreamPtr Resource::open(const std::string& name)
     {
-        return Ogre::ResourceGroupManager::getSingleton().openResource(name, group, bSearchGroupsIfNotFound);
+        return Ogre::ResourceGroupManager::getSingleton().openResource(name,
+            Ogre::ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME, true);
     }
 
-    DataStreamListPtr Resource::openMulti(const std::string& pattern, const std::string& group)
+    DataStreamListPtr Resource::openMulti(const std::string& pattern)
     {
-        return Ogre::ResourceGroupManager::getSingleton().openResources(pattern, group);
+        DataStreamListPtr resources(new Ogre::DataStreamList());
+        const Ogre::StringVector& groups = Ogre::ResourceGroupManager::getSingleton().getResourceGroups();
+        for (Ogre::StringVector::const_iterator it = groups.begin(); it != groups.end(); ++it)
+        {
+            DataStreamListPtr temp = Ogre::ResourceGroupManager::getSingleton().openResources(pattern, *it);
+            resources->insert(resources->end(), temp->begin(), temp->end());
+        }
+        return resources;
     }
 
-    bool Resource::exists(const std::string& name, const std::string& group)
+    bool Resource::exists(const std::string& name)
     {
-        return Ogre::ResourceGroupManager::getSingleton().resourceExists(group, name);
+        try
+        {
+            Ogre::ResourceGroupManager::getSingleton().findGroupContainingResource(name);
+            return true;
+        }
+        catch (const Ogre::Exception&)
+        {
+            return false;
+        }
     }
 
-    shared_ptr<ResourceInfo> Resource::getInfo(const std::string& name, const std::string& group)
+    shared_ptr<ResourceInfo> Resource::getInfo(const std::string& name)
     {
+        std::string group;
+        try
+        {
+            group = Ogre::ResourceGroupManager::getSingleton().findGroupContainingResource(name);
+        }
+        catch (const Ogre::Exception&)
+        {
+            return shared_ptr<ResourceInfo>();
+        }
         Ogre::FileInfoListPtr infos = Ogre::ResourceGroupManager::getSingleton().findResourceFileInfo(group, name);
         for (std::vector<Ogre::FileInfo>::const_iterator it = infos->begin(); it != infos->end(); ++it)
@@ -67,3 +92,15 @@
         return shared_ptr<ResourceInfo>();
     }
+
+    StringVectorPtr Resource::findResourceNames(const std::string& pattern)
+    {
+        StringVectorPtr resourceNames(new Ogre::StringVector());
+        const Ogre::StringVector& groups = Ogre::ResourceGroupManager::getSingleton().getResourceGroups();
+        for (Ogre::StringVector::const_iterator it = groups.begin(); it != groups.end(); ++it)
+        {
+            StringVectorPtr temp = Ogre::ResourceGroupManager::getSingleton().findResourceNames(*it, pattern);
+            resourceNames->insert(resourceNames->end(), temp->begin(), temp->end());
+        }
+        return resourceNames;
+    }
 }
Index: code/branches/pickup2/src/libraries/core/Resource.h
===================================================================
--- code/branches/pickup2/src/libraries/core/Resource.h	(revision 6405)
+++ code/branches/pickup2/src/libraries/core/Resource.h	(revision 6412)
@@ -34,4 +34,5 @@
 #include <boost/shared_ptr.hpp>
 #include <OgreDataStream.h>
+#include <OgreStringVector.h>
 
 namespace orxonox
@@ -40,4 +41,6 @@
     using Ogre::DataStreamList;
     using Ogre::DataStreamListPtr;
+    using Ogre::StringVector;
+    using Ogre::StringVectorPtr;
 
     //! Stores basic information about a Resource from Ogre
@@ -56,7 +59,6 @@
     };
 
-    /**
-    @brief
-        Provides simple functions to easily access the Ogre::ResourceGroupManager
+    /** Provides simple functions to easily access the Ogre::ResourceGroupManager.
+        The wrapper functions also avoid having to deal with resource groups.
     */
     class _CoreExport Resource
@@ -72,22 +74,20 @@
             Even if resource locations are added recursively, you
             must provide a fully qualified name to this method.
-        @param groupName
-            The name of the resource group; this determines which 
-            locations are searched. 
-        @param searchGroupsIfNotFound
-            If true, if the resource is not found in 
-            the group specified, other groups will be searched.
         @return
             Shared pointer to data stream containing the data. Will be
             destroyed automatically when no longer referenced.
         */
-        static DataStreamPtr open(const std::string& name,
-            const std::string& group = Resource::DEFAULT_GROUP,
-            bool bSearchGroupsIfNotFound = false);
+        static DataStreamPtr open(const std::string& name);
+
+        //! Similar to open(string, string, bool), but with a fileInfo struct
+        static DataStreamPtr open(shared_ptr<ResourceInfo> fileInfo)
+        {
+            return open(fileInfo->filename);
+        }
 
         /**
         @brief
             Open all resources matching a given pattern (which can contain
-            the character '*' as a wildcard), and return a collection of 
+            the character '*' as a wildcard), and return a collection of
             DataStream objects on them.
         @param pattern
@@ -95,30 +95,32 @@
             added recursively, subdirectories will be searched too so this
             does not need to be fully qualified.
-        @param groupName
-            The resource group; this determines which locations
-            are searched.
         @return
             Shared pointer to a data stream list , will be
             destroyed automatically when no longer referenced
         */
-        static DataStreamListPtr openMulti(const std::string& pattern, const std::string& group = Resource::DEFAULT_GROUP);
+        static DataStreamListPtr openMulti(const std::string& pattern);
 
         /**
-            Find out if the named file exists in a group. 
+            Find out if the named file exists.
         @param filename
             Fully qualified name of the file to test for
-        @param group
-            The name of the resource group
         */
-        static bool exists(const std::string& name, const std::string& group = Resource::DEFAULT_GROUP);
+        static bool exists(const std::string& name);
 
         /**
-            Get struct with information about group, path and size.
+            Get struct with information about path and size.
         @param filename
             Fully qualified name of the file to test for
-        @param group
-            The name of the resource group
         */
-        static shared_ptr<ResourceInfo> getInfo(const std::string& name, const std::string& group = Resource::DEFAULT_GROUP);
+        static shared_ptr<ResourceInfo> getInfo(const std::string& name);
+
+        /**
+            Retrieves a list with all resources matching a certain pattern.
+        @param pattern
+            The pattern to look for. If resource locations have been
+            added recursively, subdirectories will be searched too so this
+            does not need to be fully qualified.
+        */
+        static StringVectorPtr findResourceNames(const std::string& pattern);
 
         //! Name of the default resource group (usually "General")
Index: code/branches/pickup2/src/libraries/core/ScopedSingletonManager.cc
===================================================================
--- code/branches/pickup2/src/libraries/core/ScopedSingletonManager.cc	(revision 6405)
+++ code/branches/pickup2/src/libraries/core/ScopedSingletonManager.cc	(revision 6412)
@@ -47,13 +47,3 @@
         getManagersByScope().insert(std::make_pair(manager->scope_, manager));
     }
-
-    /*static*/ void ScopedSingletonManager::removeManager(ScopedSingletonManager* manager)
-    {
-        getManagers().erase(getManagers().find(manager->className_));
-        for (ManagerMultiMap::iterator it = getManagersByScope().lower_bound(manager->scope_); it != getManagersByScope().upper_bound(manager->scope_);)
-            if (it->second == manager)
-                getManagersByScope().erase(it++);
-            else
-                ++it;
-    }
 }
Index: code/branches/pickup2/src/libraries/core/ScopedSingletonManager.h
===================================================================
--- code/branches/pickup2/src/libraries/core/ScopedSingletonManager.h	(revision 6405)
+++ code/branches/pickup2/src/libraries/core/ScopedSingletonManager.h	(revision 6412)
@@ -39,4 +39,5 @@
 
 #define ManageScopedSingleton(className, scope, allowedToFail) \
+    className* className::singletonPtr_s = NULL; \
     static ClassScopedSingletonManager<className, scope, allowedToFail> className##ScopedSingletonManager(#className)
 
@@ -52,14 +53,21 @@
             virtual ~ScopedSingletonManager() { }
             static void addManager(ScopedSingletonManager* manager);
-            static void removeManager(ScopedSingletonManager* manager);
 
             template<ScopeID::Value scope>
-            static void update(const Clock& time)
+            static void preUpdate(const Clock& time)
             {
                 assert(Scope<scope>::isActive());
                 for (ManagerMultiMap::iterator it = getManagersByScope().lower_bound(scope); it != getManagersByScope().upper_bound(scope); ++it)
-                    it->second->update(time);
+                    it->second->preUpdate(time);
             }
-            virtual void update(const Clock& time) = 0;
+            virtual void preUpdate(const Clock& time) = 0;
+            template<ScopeID::Value scope>
+            static void postUpdate(const Clock& time)
+            {
+                assert(Scope<scope>::isActive());
+                for (ManagerMultiMap::iterator it = getManagersByScope().lower_bound(scope); it != getManagersByScope().upper_bound(scope); ++it)
+                    it->second->postUpdate(time);
+            }
+            virtual void postUpdate(const Clock& time) = 0;
 
             static std::map<std::string, ScopedSingletonManager*>& getManagers();
@@ -86,6 +94,4 @@
         ~ClassScopedSingletonManager()
         {
-            //assert(singletonPtr_ == NULL); // Might get triggered in the SignalHandler
-            ScopedSingletonManager::removeManager(this);
         }
 
@@ -115,9 +121,17 @@
 
         //! Called every frame by the ScopedSingletonManager
-        void update(const Clock& time)
-        {
-            assert(Scope<scope>::isActive());
-            // assuming T inherits Singleton<T>
-            singletonPtr_->updateSingleton(time);
+        void preUpdate(const Clock& time)
+        {
+            assert(Scope<scope>::isActive());
+            // assuming T inherits Singleton<T>
+            singletonPtr_->preUpdateSingleton(time);
+        }
+
+        //! Called every frame by the ScopedSingletonManager
+        void postUpdate(const Clock& time)
+        {
+            assert(Scope<scope>::isActive());
+            // assuming T inherits Singleton<T>
+            singletonPtr_->postUpdateSingleton(time);
         }
 
@@ -140,6 +154,4 @@
         ~ClassScopedSingletonManager()
         {
-            assert(singletonPtr_ == NULL);
-            ScopedSingletonManager::removeManager(this);
         }
 
@@ -150,4 +162,6 @@
             try
                 { singletonPtr_ = new T(); }
+            catch (const InitialisationAbortedException& ex)
+                { COUT(3) << ex.getDescription() << std::endl; }
             catch (...)
                 { COUT(1) << "Singleton creation failed: " << Exception::handleMessage() << std::endl; }
@@ -174,10 +188,19 @@
 
         //! Called every frame by the ScopedSingletonManager
-        void update(const Clock& time)
+        void preUpdate(const Clock& time)
         {
             assert(Scope<scope>::isActive());
             // assuming T inherits Singleton<T>
             if (singletonPtr_ != NULL)
-                singletonPtr_->updateSingleton(time);
+                singletonPtr_->preUpdateSingleton(time);
+        }
+
+        //! Called every frame by the ScopedSingletonManager
+        void postUpdate(const Clock& time)
+        {
+            assert(Scope<scope>::isActive());
+            // assuming T inherits Singleton<T>
+            if (singletonPtr_ != NULL)
+                singletonPtr_->postUpdateSingleton(time);
         }
 
